---
title: Console messages
slug: Tools/Web_Console/Console_messages
---
<div>{{ToolsSidebar}}</div>

<p>Most of the Web Console is occupied by the message display pane:</p>

<p><img alt="Screenshot of the web console, highlighting the messages area" src="https://mdn.mozillademos.org/files/17333/console-messages-Fx79.png" style="display: block; height: 345px; margin-left: auto; margin-right: auto; width: 898px;"></p>

<p>Each message is displayed as a separate row:</p>

<p><img alt="Screenshot of a single console message, with its parts annotated" src="https://mdn.mozillademos.org/files/17334/console-msg-annotated.png" style="display: block; height: 142px; margin-left: auto; margin-right: auto; width: 892px;"></p>

<table class="fullwidth-table standard-table">
 <tbody>
  <tr>
   <td><strong>Time</strong></td>
   <td>The time the message was recorded. This is not shown by default: you can opt to see timestamps by selecting <strong>Show Timestamps</strong> in the console settings menu (gear icon in the console toolbar).</td>
  </tr>
  <tr>
   <td><strong>Icon</strong></td>
   <td>
    <p>Not all console messages contain icons. The following icons may be used:</p>

    <ul>
     <li><img alt='An "i" inside a circle' src="https://mdn.mozillademos.org/files/17328/info-icon.png" style="height: 13px; width: 13px;"> Informational message</li>
     <li><img alt='A "!" inside a yellow triangle' src="https://mdn.mozillademos.org/files/17329/warning-icon.png" style="height: 14px; width: 15px;"> Warning</li>
     <li><img alt='A "!" inside a solid red circle' src="https://mdn.mozillademos.org/files/17330/error-icon.png" style="height: 14px; width: 14px;"> Error</li>
     <li><img alt="A red circle with a slash across it" src="https://mdn.mozillademos.org/files/17331/blocked-icon.png" style="height: 14px; width: 14px;"> Blocked; for network messages</li>
    </ul>

    <p>In addition, a disclosure triangle indicates that further information is available; clicking it displays or collapses that information.</p>
   </td>
  </tr>
  <tr>
   <td><strong>Message</strong></td>
   <td>The message itself.</td>
  </tr>
  <tr>
   <td><strong>Number of occurrences</strong></td>
   <td>If a line that generates a warning or error is executed more than once, it is only logged once and this counter appears to indicate how many times it was encountered.</td>
  </tr>
  <tr>
   <td><strong>Filename and line number</strong></td>
   <td>
    <p>For JavaScript, CSS and console API messages, the message can be traced to a specific line of code. The console then provides a link to the filename and line number that generated the message.</p>
   </td>
  </tr>
 </tbody>
</table>

<p>By default, the console is cleared each time you navigate to a new page or reload the current page. To override this behavior, enable <strong>Persist Logs</strong> in the console settings menu (gear icon).</p>

<p>The context menu options listed below are available on all message categories. Additional context menu options are described in the subsection for the message category they apply to.</p>

<ul>
 <li><strong>Copy Message</strong> copies the selected message to the clipboard.</li>
 <li><strong>Select All</strong> selects all messages available in the message display pane.</li>
 <li><strong>Export Visible Messages To</strong>
  <ul>
   <li><strong>Clipboard</strong> copies all messages available in the display pane to the clipboard.</li>
   <li><strong>File</strong> opens a file dialog box so you can save an export of all messages available in the display pane.</li>
  </ul>
 </li>
</ul>

<h2 id="Message_categories">Message categories</h2>

<h3 id="Network">Network</h3>

<div class="note">
<p>Network log messages are not shown by default. Use the <a href="/en-US/docs/Tools/Web_Console/Console_messages#Filtering_by_category">filtering</a> feature to show them.</p>
</div>

<p>Network requests are logged with a line that looks like this:</p>

<p><img alt="Screenshot of a network response message, with its parts annotated" src="https://mdn.mozillademos.org/files/17335/response-msg-annotated.png" style="display: block; height: 133px; margin-left: auto; margin-right: auto; width: 891px;"></p>

<table class="fullwidth-table standard-table">
 <tbody>
  <tr>
   <td><strong>Time</strong></td>
   <td>The time the message was recorded.</td>
  </tr>
  <tr>
   <td><strong>Method</strong></td>
   <td>
    <p>The specific HTTP request method.</p>

    <p>If the request was made as an <a href="/en-US/docs/Web/API/XMLHttpRequest">XMLHttpRequest</a>, there's an additional "XHR" tag indicating this.</p>

    <p>If more information is available, a disclosure triangle lets you display it, in an embedded panel that is identical to the <a href="/en-US/docs/Tools/Network_Monitor/request_details">Network Monitor request details</a>.</p>
   </td>
  </tr>
  <tr>
   <td><strong>URI</strong></td>
   <td>The target URI.</td>
  </tr>
  <tr>
   <td><strong>Summary</strong></td>
   <td>The HTTP version, response code, and time taken to complete. Clicking the response code takes you to the reference page for that code.</td>
  </tr>
 </tbody>
</table>

<p>{{EmbedYouTube("cFlcWzJ9j4I")}}</p>

<p>The context menu for network messages includes a few extra items in addition the globally-available ones:</p>

<p><img alt="Screenshot showing the context menu for network response messages" src="https://mdn.mozillademos.org/files/17336/response-msg-context-menu.png" style="border: 1px solid black; display: block; height: 249px; margin: 0px auto; width: 481px;"></p>

<dl>
 <dt>Copy link location</dt>
 <dd>Acts as you would expect, copying the URL into the clipboard</dd>
 <dt>Open in Network Panel</dt>
 <dd>Switches context to the Network tab, selects the request and shows you the details</dd>
 <dt>Resend Request</dt>
 <dd>Sends the network request again.</dd>
 <dt>Open URL in New Tab</dt>
 <dd>Opens the URL in a new browser tab. If the resource is an image, the image will be opened in a new tab. If the resource is a stylesheet, you will see the CSS rules, etc.</dd>
</dl>

<h3 id="JS">JS</h3>

<p>JavaScript errors contain a "Learn more" link that takes you to the<a href="/en-US/docs/Web/JavaScript/Reference/Errors"> JavaScript error reference</a> containing additional advice for fixing issues:</p>

<p>{{EmbedYouTube("OabJc2QR6o0")}}</p>

<h4 id="Source_maps">Source maps</h4>

<p>The Web Console understands <a href="http://blog.teamtreehouse.com/introduction-source-maps">source maps</a>. This means that if your JavaScript sources are compressed, you can supply a source map for them. Then any messages or errors your source generates will show up in the Web Console with a link back to the original source, not the compressed version.</p>

<h4 id="Async_stack_frames">Async stack frames</h4>

<p>Stack traces show stack frames for <a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function">async functions</a> separately from those for synchronous functions. When you run code containing an async function, its traces (<a href="/en-US/docs/Web/API/Console/trace">console.trace</a> or <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Error">thrown error</a>) are shown with an <em>Async:</em> prefix.</p>

<p><img alt="Console log showing a trace containing async code" src="https://mdn.mozillademos.org/files/17026/Async-trace.png" style="height: 442px; width: 771px;"></p>

<h3 id="CSS">CSS</h3>

<div class="note">
<p><strong>Note</strong>: CSS warnings and reflow messages are not shown by default, for performance reasons (see {{bug(1452143)}}). Use the <a href="/en-US/docs/Tools/Web_Console/Console_messages#Filtering_by_category">filtering</a> feature to show them.</p>
</div>

<p>Some CSS messages contain a disclosure triangle at the left of the message. Click it to view more information about the error, as well as which DOM nodes are affected by the error.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16674/css_warnings.png" style="display: block; height: 346px; margin: 0px auto; width: 918px;"></p>

<h3 id="Security">Security</h3>

<p>The security messages shown in the Web Console help developers find potential or actual vulnerabilities in their sites. Additionally, many of these messages help educate developers because they end with a “Learn More” link that takes you to a page with background information and advice for mitigating the issue.</p>

<p>The complete list of security messages is as follows:</p>

<table class="standard-table" style="width: auto;">
 <tbody>
  <tr>
   <th scope="col">Message</th>
   <th scope="col">Details</th>
  </tr>
  <tr>
   <td>Blocked loading mixed active content</td>
   <td>The page contained mixed active content: that is, the main page was served over HTTPS, but asked the browser to load "active content", such as scripts, over HTTP. The browser blocked this active content. See <a href="/en-US/docs/Security/MixedContent">Mixed Content</a> for more details.</td>
  </tr>
  <tr>
   <td>Blocked loading mixed display content</td>
   <td>The page contained mixed display content: that is, the main page was served over HTTPS, but asked the browser to load "display content", such as images, over HTTP. The browser blocked this display content. See <a href="/en-US/docs/Security/MixedContent">Mixed Content</a> for more details.</td>
  </tr>
  <tr>
   <td>Loading mixed (insecure) active content on a secure page</td>
   <td>The page contained mixed active content: that is, the main page was served over HTTPS, but asked the browser to load "active content", such as scripts, over HTTP. The browser loaded this active content. See <a href="/en-US/docs/Security/MixedContent">Mixed Content</a> for more details.</td>
  </tr>
  <tr>
   <td>Loading mixed (insecure) display content on a secure page</td>
   <td>The page contained mixed display content: that is, the main page was served over HTTPS, but asked the browser to load "display content", such as images, over HTTP. The browser loaded this display content. See <a href="/en-US/docs/Security/MixedContent">Mixed Content</a> for more details.</td>
  </tr>
  <tr>
   <td>This site specified both an X-Content-Security-Policy/Report-Only header and a Content-Security-Policy/Report-Only header. The X-Content-Security-Policy/Report-Only header(s) will be ignored.</td>
   <td>See <a href="/en-US/docs/Security/CSP">Content Security Policy</a> for more details.</td>
  </tr>
  <tr>
   <td>The X-Content-Security-Policy and X-Content-Security-Report-Only headers will be deprecated in the future. Please use the Content-Security-Policy and Content-Security-Report-Only headers with CSP spec compliant syntax instead.</td>
   <td>See <a href="/en-US/docs/Security/CSP">Content Security Policy</a> for more details.</td>
  </tr>
  <tr>
   <td>Password fields present on an insecure (http://) page. This is a security risk that allows user login credentials to be stolen.</td>
   <td>Pages containing login forms must be served over HTTPS, not HTTP.</td>
  </tr>
  <tr>
   <td>Password fields present in a form with an insecure (http://) form action. This is a security risk that allows user login credentials to be stolen.</td>
   <td>Forms containing password fields must submit them over HTTPS, not HTTP.</td>
  </tr>
  <tr>
   <td>Password fields present on an insecure (http://) iframe. This is a security risk that allows user login credentials to be stolen.</td>
   <td>iframes containing login forms must be served over HTTPS, not HTTP.</td>
  </tr>
  <tr>
   <td>The site specified an invalid Strict-Transport-Security header.</td>
   <td>See <a href="/en-US/docs/Security/HTTP_Strict_Transport_Security">HTTP Strict Transport Security</a> for more details.</td>
  </tr>
  <tr>
   <td>
    <p>This site makes use of a SHA-1 Certificate; it's recommended you use certificates with signature algorithms that use hash functions stronger than SHA-1.</p>
   </td>
   <td>
    <p>The site uses a certificate whose signature uses the SHA-1 hash algorithm.</p>

    <p>SHA-1 is still widely used in certificates, but it is starting to show its age. Web sites and Certification Authorities are encouraged to switch to stronger hash algorithms in future. See the <a href="/en-US/docs/Security/Weak_Signature_Algorithm">Weak Signature Algorithm</a> article for more details.</p>

    <p>Note that the SHA-1 certificate may not be your site's own certificate, but may be the certificate belonging to a Certification Authority that was used to sign your site's certificate.</p>
   </td>
  </tr>
 </tbody>
</table>

<p><a href="https://bugzilla.mozilla.org/show_bug.cgi?id=863874">Bug 863874</a> is the meta-bug for logging relevant security messages to the Web Console. If you have more ideas for useful features like the ones discussed here, or are interested in contributing, check out the metabug and its dependencies.</p>

<h3 id="Logging">Logging</h3>

<div class="note">
<p>Messages logged from <a href="/en-US/docs/Web/API/SharedWorker">Shared Workers</a>, <a href="/en-US/docs/Web/API/ServiceWorker_API">Service Workers</a>, add-ons, and <a href="/en-US/docs/Mozilla/ChromeWorkers">Chrome Workers</a> are not shown by default. Use the <a href="/en-US/docs/Tools/Web_Console/Console_messages#Filtering_by_category">filtering</a> feature to show them.</p>
</div>

<p>The Logging category includes messages logged using the <a href="/en-US/docs/Web/API/Console">Console</a> API.</p>

<p>The Web console supports the following <a href="/en-US/docs/Web/API/Console">Console API</a> messages:</p>

<ul>
 <li><a href="/en-US/docs/Web/API/Console.assert"><code>assert()</code></a></li>
 <li><code><a href="/en-US/docs/Web/API/Console/clear">clear()</a></code></li>
 <li><a href="/en-US/docs/Web/API/Console.count"><code>count()</code></a></li>
 <li><a href="/en-US/docs/Web/API/Console.dir"><code>dir()</code></a></li>
 <li><a href="/en-US/docs/Web/API/Console.dirxml"><code>dirxml()</code></a></li>
 <li><a href="/en-US/docs/Web/API/Console.error"><code>error()</code></a></li>
 <li><code>exception()</code></li>
 <li><code><a href="/en-US/docs/Web/API/Console.group">group()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/Console/groupEnd">groupEnd()</a></code></li>
 <li><code>info()</code></li>
 <li><a href="/en-US/docs/Web/API/Console.log"><code>log()</code></a></li>
 <li><a href="/en-US/docs/Web/API/Console.table"><code>table()</code></a></li>
 <li><a href="/en-US/docs/Web/API/Console.time"><code>time()</code></a></li>
 <li><a href="/en-US/docs/Web/API/Console.timeEnd"><code>timeEnd()</code></a></li>
 <li><a href="/en-US/docs/Web/API/Console.trace"><code>trace()</code></a></li>
 <li><a href="/en-US/docs/Web/API/Console.warn"><code>warn()</code></a></li>
</ul>

<p>The console prints a stack trace for all error messages, like this:</p>

<pre class="brush: js notranslate">function foo() {
  console.error("it explodes");
}

function bar() {
  foo();
}

function doStuff() {
 bar();
}

doStuff();</pre>

<p><img alt="" src="https://mdn.mozillademos.org/files/11665/error-stack.png" style="display: block; height: 92px; margin-left: auto; margin-right: auto; width: 465px;"></p>

<h3 id="Server">Server</h3>

<div class="note">
<p>Server-side log messages was introduced in Firefox 43, but removed in Firefox 56. You can install the <a href="https://addons.mozilla.org/en-US/firefox/addon/chromelogger/">Chrome Logger extension</a> to (re)-enable the feature.</p>
</div>

<p>With the <a href="https://addons.mozilla.org/en-US/firefox/addon/chromelogger/">Chrome Logger extension</a>, Web Console can display messages sent from the server. This enables you to use the Web Console to debug server-side code.</p>

<p>It uses the <a href="https://craig.is/writing/chrome-logger">Chrome Logger</a> protocol. Briefly, the way it works is:</p>

<ul>
 <li>Your server-side code — Python, PHP, Node.js, etc. — includes a library that provides a console API.</li>
 <li>Your server-side code uses this API to log messages.</li>
 <li>The server-side library creates JSON objects from the messages and encodes them for transmission.</li>
 <li>The messages are transmitted to the client as a response header named <code>X-ChromeLogger-Data</code>.</li>
 <li>The Web Console decodes these headers and displays them.</li>
</ul>

<p>To find a suitable library for your server code, see the <a href="https://craig.is/writing/chrome-logger">Chrome Logger documentation</a>.</p>

<h3 id="Interpreter_inputoutput">Interpreter input/output</h3>

<p>Commands sent to the browser using the <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter" title="#command-line">Web Console's JavaScript interpreter</a>, and the corresponding responses, are logged in the console messages.</p>

<p>For responses that contain objects or variables, the following context menu options are available:</p>

<dl>
 <dt>Reveal in Inspector</dt>
 <dd>Shows the selected DOM node in the Inspector pane.</dd>
 <dt>Store as Global Variable</dt>
 <dd>Creates a global variable (with a name like <code>temp0</code>, <code>temp1</code>, etc.) whose value is the selected object. The name of the variable appears as an input to the interpreter, and its value appears as a response.</dd>
 <dt>Copy Object</dt>
 <dd>Copies the selected object to the clipboard.</dd>
</dl>

<h2 id="Filtering_and_searching"><a name="filtering-and-searching">Filtering and searching</a></h2>

<h3 id="Filtering_by_category">Filtering by category</h3>

<p>You can use the toolbar along the top to constrain the results displayed.</p>

<p><img alt="Screenshot showing the web console, with the toolbar highlighted" src="https://mdn.mozillademos.org/files/17337/console-toolbar.png" style="display: block; height: 148px; margin-left: auto; margin-right: auto; width: 968px;">To see only messages of particular categories, click the button labeled with that category (<strong>Errors</strong>, <strong>CSS</strong>, and so on).</p>

<p>For Errors and Warnings, when you turn off display of the category, a number appears next to the button text to indicate how many messages of that type are available. For example, "Warnings (25)".</p>

<p>Network requests with response codes in the 400-499 (client error) or 500-599 (server error) ranges are considered errors. Their display is controlled by the <strong>Errors</strong> button, not the <strong>Requests</strong> button.</p>

<h3 id="Filtering_by_text">Filtering by text</h3>

<p>To see only messages that contain a specific string, type in the text box labeled "Filter output". For example, if you entered the string img into the text box, you would have a list something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16621/console_clear_filter.png" style="border: 1px solid black; display: block; height: 169px; margin: 0px auto; width: 600px;"></p>

<p>A small "x" icon appears at the right end of the text box when you have entered a string on which to filter the output. Click the "x" icon to clear the filter and show the entire list again.</p>

<p>You can negate a text search by prefixing it with the <code>-</code> character. For example, <code>-img</code> shows only items that <em>do not</em> contain the string <code>img</code>.</p>

<h3 id="Filtering_with_Regular_Expressions">Filtering with Regular Expressions</h3>

<p>You can also use a valid regular expression to filter the console output. For example, the following video shows the results when filtering on two simple regular expressions: <code>/(cool|rad)/</code> and <code>/(cool)/</code>.</p>

<p>{{EmbedYouTube("E6bGOe2fvW0")}}</p>

<p>You can negate a regular expression search by prefixing it with the <code>-</code> character. For example, <code>-/(cool|rad)/</code> shows only items that <em>do not</em> match the expression <code>/(cool|rad)/</code>.</p>

<h3 id="Clearing_the_log">Clearing the log</h3>

<p>Finally, you can use the trashcan icon on the left to clear the contents of the console. When you clear the console, the console cache is also cleared. This prevents errors that have already been loged from reappearing when you reopen the console.</p>
